package App::Nighttime::CGI;

use strict;
use warnings;

use parent 'App::Nighttime';

use CGI::Simple;
use File::Temp;

sub _schedule_wakeup($$$) {
  my ($self, $ip, $time) = @_;

  my $c   = $self->config;
  my $db  = $c->{db}
    or $self->croak("No DB directory configured.");

  my $new = File::Temp->new(
    TEMPLATE => "new-XXXXX",
    UNLINK   => 0,
    DIR      => "$db/new",
  );
  print $new "$time\n$ip\n";
  unless (chmod 0644, "$new") {
    unlink "$new";
    $self->croak("Could not change mode of new request.");
  }

  return 1;
}

sub run($) {
  my ($self) = @_;

  my $q = new CGI::Simple;

  my $ip = $ENV{REMOTE_ADDR}
    or $self->croak("Unknown remote IP address.");
  defined $q->param("time")
    or $self->croak("No time specified.");
  my $time = int $q->param("time");
  my $now  = time;

  if ($time < $now) {
    $self->croak("Cannot wakeup client in the past.");
  }

  $self->_schedule_wakeup($ip, $time);

  print $q->header("text/plain");
  print "ok.";
}

1;
# vim: et sw=2:
