package App::Nighttime::HostInfo;

use strict;
use warnings;

use Carp;

our %_TYPES = (
  LDAP => "App::Nighttime::HostInfo::LDAP",
);

sub new {
  my ($class, $type, $options) = @_;

  my $package = $_TYPES{$type}
    or croak "Unknown host info type '$type'";

  eval "use $package";
  return $package->new($options);
};

1;
# vim: et sw=2:
